#include <stdlib.h>
#include <stdio.h>
#include <strings.h>

extern char	*speed_ext;

/* shaperd_strtoi(char *str)
 * Funkcja zwraca wartosc liczbowa podanego napisu
 * dozwolony format napisu to:
 * ~0[0-9]*       liczba w formacie dziesietnym
 * 0[0-9]+        liczba w formacie osemkowym
 * 0x[0-9a-fA-F]+ liczba w formacie szesnastkowym
 */
int shaperd_strtoi(char *str)
{
    int base=10;
    int offset=0;

    if (!str) {
	fprintf(stderr,"shaperd_strtoi: null pointer error.\n");
	exit(1);
    }

    if (str[0]=='0') {
	if (str[1]=='x') {
	    base=16;
	    offset=2;
	} else {
	    base=8;
	    offset=1;
	}
    }
    
    return strtol(str+offset,(char **)NULL,base);
}

/* shaperd_strtobool(char *str)
 *
 * zwraca:
 *   1, gdy str to "yes","true"
 *   0, gdy str to "no","false"
 *   shaperd_strtoi(str) w kazdym innym przypadku
 * nie jest ,,case-sensitive''
 */
int shaperd_strtobool(char *str)
{
    if (!strcasecmp("yes",str))
	return 1;
    if (!strcasecmp("true",str))
	return 1;
    if (!strcasecmp("no",str))
	return 0;
    if (!strcasecmp("false",str))
	return 0;
    return shaperd_strtoi(str);
}

/* int shaperd_strtoclass(char *str)
 * zwraca:
 *   0, gdy str to "cbq",
 *   1, gdy str to "htb",
 *   -1 w przeciwnym wypadku
 * nie jest ,,case-sensitive''
 */
int shaperd_strtoclass(char *str)
{
    if (!strcasecmp("cbq",str))
	return 0;
    if (!strcasecmp("htb",str))
	return 1;
    return 1;    
}

/* const char *shaperd_strtospeedu(char *str)
 * zwraca:
 *   "bit", gdy str to "bit",
 *   "kbit", gdy str to "kbit",
 *   "mbit", gdy str to "mbit",
 *    NULL w przeciwnym wypadku
 * nie jest ,,case-sensitive''
 */
const char *shaperd_strtospeedu(char *str)
{
    if (!strcasecmp("bit",str))
	return "bit";
    if (!strcasecmp("kbit",str))
	return "kbit";
    if (!strcasecmp("mbit",str))
	return "mbit";
    return NULL;
}
