#ifndef __SHAPERD_OLD_H__
#define __SHAPERD_OLD_H__

#include "read_iplist.h"

struct FLAGI
{
    unsigned int clear_firewall_done : 1;
    unsigned int clear_firewall_done_counter : 4;
};

struct WRR
{
    unsigned long int max_speed; // max szybkosc lacza internetowego
    unsigned int direction : 1; // 0=download 1=upload
    unsigned int classify : 1; // 0=ip 1=masq
    unsigned int force_penalty : 1; // 1 - wymusza penalty
    unsigned int maxclasses; // ilosc klas na interfejsie + 1
    unsigned int proxymaxcon;
    unsigned int mode1;
    unsigned int mode2;
    float min1;
    float max1;
    float decr1;
    float incr1;
    float weight1;
    float min2;
    float max2;
    float decr2;
    float incr2;
    float weight2;
};

void frmem(void);
void error(char *, ...);
int my_system (const char *);
void exit_handler();
void reload_handler();
void clear_handler();
void diff_handler();
int numlines(char *);
unsigned long int ckbitrate_user(char *);
unsigned long int ckbitrate_user_upload(char *);
void read_firewall(int);
int is_clean_firewall(int);
int is_clean_firewall2(int);
void read_firewall_upload(int);
void write_bitrate(char *);
char **dev_list(void);
void cbq_off(char *);
void cbq_off_local(char ***);
void cbq_off_all(char ***);
void cbq_setup_root(char *, unsigned long int, int, int, struct WRR wrr);
void cbq_ingress_root(char *);
void cbq_setup_clas(char *, unsigned long int, int, char *, char *, int, struct WRR wrr);
void wrr_penalty(char *, unsigned long int, int, char *, char *, int, struct WRR wrr);
void cbq_setup_xfilters(char *, int, char *, char *, int);
void cbq_class_add(char *, unsigned long int, unsigned long int, int, int, char *, char *, int , int, char *, int, struct IPLISTA * ptr);
void cbq_ingress_add(char *, unsigned long int, int, int, char *, char *, int);
void cbq_class_change(char *, unsigned long int, unsigned long int, int, int, char *, char *, int , int, char *, int, struct IPLISTA * ptr);
void cbq_ingress_change(char *, unsigned long int, int, int, char *, char *, int);
void cbq_class_del(char *, unsigned long int, unsigned long int, int, int, char *, char *, int , int, char *, int, struct IPLISTA * ptr);
void cbq_ingress_del(char *, unsigned long int, int, int, char *, char *, int);
void cbq_class_add_upload(char *, unsigned long int, unsigned long int, int, int, char *, char *, int , int, char *, int, struct IPLISTA * ptr);
void cbq_class_change_upload(char *, unsigned long int, unsigned long int, int, int, char *, char *, int , int, char *, int, struct IPLISTA * ptr);
void cbq_class_del_upload(char *, unsigned long int, unsigned long int, int, int, char *, char *, int , int, char *, int, struct IPLISTA * ptr);
void cbq_standard_on(char ***);
void wrr_penalty2(char ***);
char ***read_config(char *);
void free_config(char ***);
char ***natstat(char **, char ***, int);
char ***natstat_upload(char **, char ***, int);
void free_natstat_tab(char ***);
void free_natstat_tab_upload(char ***);
char **read_ignore(char *);
void free_ignore(char **);
char **get_masqip(char ***, char *, int);
char **get_masqip_upload(char ***, char *, int);
void free_masqip(char **, int);
void free_masqip_upload(char **, int);
char ***create_speed_table(int);
void free_speed_table(char ***, int);
void add_ip2speed_table_new(char ***,char *);
void add_ip2speed_table_sub1(char ***,char *);
void add_ip2speed_table_nop1(char ***,char *);
void add_ip2speed_table_add1(char ***,char *);
void add_ip2speed_table_sub2(char ***,char *);
void add_ip2speed_table_nop2(char ***,char *);
void add_ip2speed_table_add2(char ***,char *);
void del_ip2speed_table(char ***,char *);
char *get_speed_table_new(char ***, int);
char *get_speed_table_sub1(char ***, int);
char *get_speed_table_nop1(char ***, int);
char *get_speed_table_add1(char ***, int);
char *get_speed_table_sub2(char ***, int);
char *get_speed_table_nop2(char ***, int);
char *get_speed_table_add2(char ***, int);
char *get_speed_table_del(char ***, int);
char *get_ip_iface(char *);
char *get_ip_iface_str(struct IPLISTA *ptr);
char *get_ip_int_iface(char *);
char *get_ip_int_iface_str(struct IPLISTA *ptr);
int get_ip_factor(char *);
int get_ip_upload_factor(char *);
unsigned short int get_ip_cnt(char *);
//unsigned short int get_ip_cnt2(char *, struct IPLISTA *ptr, int);
unsigned short int get_ip_cnt2(struct IPLISTA *ptr_curr, struct IPLISTA *ptr_search, int iplista_pos_new);
int get_ip_mask(char *);
unsigned long int get_ip_lospeed(char *);
unsigned long int get_ip_hispeed(char *);
unsigned long int get_ip_lospeed_upload(char *);
unsigned long int get_ip_hispeed_upload(char *);
int islimit(char *);
int islimit_upload(char *ip);
int get_config_by_ip(char ***, char *);
int get_config_by_ip_str(char ***, struct IPLISTA *ptr);
int get_config_by_ip_upload(char ***, char *);
int get_config_by_ip_upload_str(char ***, struct IPLISTA *ptr);
char *check_mask(char *);
int ip2hex(char *);
int ip2hex2(char *);
int ip2hex3(char *);
char *hex2ip(int);
char *hex2ip2(char *);
char *get_ip_iface2(char ***, char *);
int mask2hex(char *);
void create_firewall(char ***, int);
void delete_firewall(char ***, int);
void clear_firewall(int);
/** ZQ **/
unsigned long int   *create_bitrate_tab(int );
char ***mkbitrate_user_last(char ***, char *, long int, int);
char ***mkbitrate_user_last_upload(char ***, char *, long int, int);
char ***clear_bitrate_user_last(char ***, char **, int);
char ***clear_bitrate_user_last_upload(char ***, char **, int);
long int ckbitrate_user_last(char ***, char *, int);
long int ckbitrate_user_last_upload(char ***, char *, int);
void set_bitrate_user_last(char ***, char *, int, char *);
void set_bitrate_user_last_upload(char ***, char *, int, char *);
void free_bitrate_user_last(char ***, int);
void free_bitrate_user_last_upload(char ***, int);
void write_bitrate_user_last(char ****,char *, int);
void write_bitrate_user_last_upload(char ****, char *, int);
int check_linux(void);
int check_ipchains(void);
int check_iptables(void);
int is_shaperd_running(void);
int is_iproute2(void);
int is_htb3(void);
int is_qos(void);
int is_imq(void);
void shownat(char ***);
char *lower(char *);
void read_squid(int);
void read_sqout(int);
char *ip2ip_with_mask(char *);
char *get_mainip(char *);
int count_char_in_string(char *, char);
int is_device(char *);
void putdate(void);
void putstring(char *, ...);
int numcmp(int, int);
void qsort2(char **, int *, int *, int, int);
int mask2hex2(char *);
int multipler(void);
struct IPLISTA * get_ip_str(char *);

#endif
